// DRA818V_VHF_16_ISS_2

/*********************************************************************
This is an example sketch for our Monochrome Nokia 5110 LCD Displays
  Pick one up today in the adafruit shop!
  ------> http://www.adafruit.com/products/338
These displays use SPI to communicate, 4 or 5 pins are required to
interface
Adafruit invests time and resources providing this open source code,
please support Adafruit and open-source hardware by purchasing
products from Adafruit!
Written by Limor Fried/Ladyada  for Adafruit Industries.
BSD license, check license.txt for more information
All text above, and the splash screen must be included in any redistribution
*********************************************************************/
 #include <Adafruit_GFX.h>
 #include <Adafruit_PCD8544.h>
 #include <SPI.h>
 
Adafruit_PCD8544 display = Adafruit_PCD8544(13, 11, 5, 7, 6);

int ch, sensorValue;
int ch_old = 1;

// set parameters for DRA818V
int bw = 1;                              // bandwith in KHz ( 0 = 12.5 or 1 = 25 )
double ftx;                              // tx frequency in MHz (134.0000 - 174.0000)
double frx;                              // rx frequency in MHz (134.0000 - 174.0000) 
String tx_ctcss = "0000";                   // ctcss frequency ( 0000 - 0038 ); 0000 = "no CTCSS"  
String rx_ctcss = "0000";                   // ctcss frequency ( 0000 - 0038 ); 0000 = "no CTCSS"  
int squ = 0;                                // squelch level  ( 0 - 8 ); 0 = "open"  

void setup()
{
  Serial.begin(9600);                      // open serial at 9600 bps
  display.begin();
  display.setContrast(60);
  display.setCursor(5,40);
  display.print("(C)DJ7OO 2014");
  display.display();
  delay(2000);
//  display.clearDisplay();   // clears the screen and buffer
}

void loop()
{
sensorValue = analogRead(0);
ch = sensorValue/65;    // 16-Kanalversion (0-15)
if (ch != ch_old)
{
     if (ch == 0) { ftx = 144.8000; frx = 144.8000; squ = 0; }    
else if (ch == 1) { ftx = 145.9250; frx = 144.9250; squ = 0; }    
else if (ch == 2) { ftx = 144.9750; frx = 144.9750; squ = 0; }    
else if (ch == 3) { ftx = 145.5000; frx = 145.5000; squ = 0; }     
else if (ch == 4) { ftx = 145.5250; frx = 145.5250; squ = 0; }    
else if (ch == 5) { ftx = 145.5500; frx = 145.5500; squ = 0; }    
else if (ch == 6) { ftx = 145.5750; frx = 145.5750; squ = 0; }    
else if (ch == 7) { ftx = 145.0000; frx = 145.6000; squ = 1; }    
else if (ch == 8) { ftx = 145.0250; frx = 145.6250; squ = 1; }    
else if (ch == 9) { ftx = 145.0500; frx = 145.6500; squ = 1; }    
else if (ch == 10) { ftx = 145.0750; frx = 145.6750; squ = 1; }    
else if (ch == 11) { ftx = 145.1000; frx = 145.7000; squ = 1; }    
else if (ch == 12) { ftx = 145.1250; frx = 145.7250; squ = 1; }    
else if (ch == 13) { ftx = 145.1500; frx = 145.7500; squ = 1; }    
else if (ch == 14) { ftx = 145.1750; frx = 145.7750; squ = 1; }    
else if (ch == 15) { ftx = 145.8250; frx = 145.8250; squ = 0; }    

  Serial.print("AT+DMOSETGROUP=");         // begin message but don't send yet..
  Serial.print(bw);
  Serial.print(",");
  Serial.print(ftx,4); 
  Serial.print(",");
  Serial.print(frx,4);
  Serial.print(",");
  Serial.print(tx_ctcss);
  Serial.print(",");
  Serial.print(squ);
  Serial.print(",");
  Serial.println(rx_ctcss);

  display.clearDisplay();   // clears the screen and buffer
  display.setTextSize(2);
  display.setTextColor(BLACK);
  display.setCursor(0,0);
  display.print(frx,3);
  display.setTextSize(1);
  display.setCursor(0,24);
  display.print("Ch.");
  display.print(ch+1);
  display.setCursor(64,16);
  display.print("MHz");
  display.setCursor(5,40);
  display.print("(C)DJ7OO 2014");
  display.display();
  delay(100);
  ch_old = ch;
 }
}

